<?php
/*
Plugin Name: WPContaxe
Plugin URI: http://www.contaxe.com
Description: Contaxe-Werbemittel in Ihren Wordpress-Blog einbinden.
Version: 1.0.1
Author: Contaxe
Author URI: http://www.contaxe.com
*/

require_once(dirname(__FILE__) . '/defines.php');

if (!class_exists('WPContaxe')) {

class WPContaxe {
	var $adminOptionsName	= 'wpcontaxe';
	var $options			= NULL;
	var $numWidgets			= 3;
	var $cntBanners			= 0;

	function activatePlugin() {
		$this->getAdminOptions();
	}

	function getAdminOptions() {
		if (isset($this->options)) return $this->options;

		$admin_options = array(
			'global_channel'		=> '',
			'global_adminssee'		=> 'demo',		// current_user_can('manage_options')
			'global_userssee'		=> 'ads',		// is_user_logged_in
			'global_visitorssee'	=> 'ads',		// else ...
			'highlighter_enabled'	=> false,
			'highlighter_channel'	=> '',			// c
			'highlighter_style'		=> '',			// s
			'highlighter_words'		=> 5,			// hw	1-10
			'highlighter_repeat'	=> 5,			// wr	1-100
			'highlighter_delay'		=> 2000,		// pct	500-4000
			'highlighter_charset'	=> 0,			// cs
			'highlighter_bigfont'	=> false,		// t=20 - small; t=54 - big
			'ias_enabled'			=> false,
			'ias_channel'			=> '',			// c
			'ias_style'				=> '',			// s
			'ias_type'				=> 57,			// t=55 - 1 ad; t=56 - 2 ads; t=57 - 5 titles; t=58 - 10 titles
			'widgets'				=> array(),		// sidebar widgets
			'banners'				=> array(),		// banners
			'positions'				=> array(),		// positions
		);
		$options = get_option($this->adminOptionsName);
		if (!empty($options)) {
			foreach ($options as $key => $option) $admin_options[$key] = $option;
		}
		for ($i = 1; $i <= $this->numWidgets; $i++) {
			if (!isset($admin_options['widgets'][$i])) {
				$admin_options['widgets'][$i] = array(
					'title'		=> 'Anzeige',
					'banner'	=> NULL
				);
			}
		}
		update_option($this->adminOptionsName, $admin_options);
		$this->options = $admin_options;
		return $this->options;
	}

	function registerAdminMenu() {
		add_menu_page('Contaxe-Werbung', 'Contaxe-Werbung', 9, __FILE__, array(&$this, 'adminGeneralSettings'));
		add_submenu_page(__FILE__, 'Allgemein', 'Allgemein', 9, __FILE__, array(&$this, 'adminGeneralSettings'));
		add_submenu_page(__FILE__, 'Highlighter', 'Highlighter', 9, 'wpcontaxe/admin/highlighter.php');
		add_submenu_page(__FILE__, 'Intelligent Search Ad', 'Intelligent Search Ad', 9, 'wpcontaxe/admin/ias.php');
		add_submenu_page(__FILE__, 'Banner', 'Banner', 9, 'wpcontaxe/admin/banner.php');
		add_submenu_page(__FILE__, 'Banner positionieren', 'Banner positionieren', 9, 'wpcontaxe/admin/positions.php');
	}

	function adminGeneralSettings() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateGeneralSettings'])) {
			check_admin_referer('wpcontaxe-update-general');
			$options['global_channel']		= $_POST['channel'];
			$options['global_adminssee']	= $_POST['adminssee'];
			$options['global_userssee']		= $_POST['userssee'];
			$options['global_visitorssee']	= $_POST['visitorssee'];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/general-settings-form.php');
	}

	function adminHighlighter() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateHighlighterSettings'])) {
			check_admin_referer('wpcontaxe-update-highlighter');
			$options['highlighter_enabled']	= $_POST['enabled'] == 'true';
			$options['highlighter_channel']	= $_POST['channel'];
			$options['highlighter_style']	= $_POST['style'];
			$options['highlighter_bigfont']	= $_POST['bigfont'] == 'true';
			if (is_numeric($_POST['words']))	$options['highlighter_words']	= min(10,   max(1,   $_POST['words'] ));
			if (is_numeric($_POST['repeat']))	$options['highlighter_repeat']	= min(100,  max(1,   $_POST['repeat']));
			if (is_numeric($_POST['delay']))	$options['highlighter_delay']	= min(4000, max(500, $_POST['delay'] ));
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/highlighter-settings-form.php');
	}

	function adminIAS() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateIASSettings'])) {
			check_admin_referer('wpcontaxe-update-ias');
			$options['ias_enabled']	= $_POST['enabled'] == 'true';
			$options['ias_channel']	= $_POST['channel'];
			$options['ias_style']	= $_POST['style'];
			$options['ias_type']	= $_POST['type'];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/ias-settings-form.php');
	}

	function adminPositions() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updatePositions'])) {
			check_admin_referer('wpcontaxe-update-positions');
			foreach ($_POST['banner'] as $key => $value) {
				if (empty($value)) {
					unset($options['positions'][$key]);
					continue;
				}
				$options['positions'][$key] = array(
					'banner'	=> $value,
					'position'	=> isset($_POST['position'][$key]) ? $_POST['position'][$key] : 1
				);
			}
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/positions-form.php');
	}

	function adminBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_REQUEST['action'])) {
			include(dirname(__FILE__) . '/admin/list-banners.php');
			return;
		}
		switch ($_REQUEST['action']) {
			case 'add':
				if ($this->addBanner()) break;
				include(dirname(__FILE__) . '/admin/edit-banner.php');
				return;
			case 'edit':
//				if ($this->editBanner()) break;
				$this->editBanner();
				include(dirname(__FILE__) . '/admin/edit-banner.php');
				return;
			case 'delete':
				$this->deleteBanner();
				break;
			default:
				echo 'Unbekannte Aktion.';
				return;
		}
		$options = $this->getAdminOptions();
		include(dirname(__FILE__) . '/admin/list-banners.php');
	}

	function addBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_POST['action'])) return false;
		check_admin_referer('wpcontaxe-add_');

//		if (!isset($GLOBALS['WPCONTAXE_ADFORMATS'][$_POST['format']])) {
//			$msg	.= '<li>Bitte wählen Sie ein Format.</li>';
//		}
		end($options['banners']);
		$id = key($options['banners']) + 1;
		$options['banners'][$id]	= array(
			'id'		=> $id,
			'name'		=> empty($_POST['name']) ? 'Unbenannt ' . $id: $_POST['name'],
			'channel'	=> $_POST['channel'],
			'format'	=> $_POST['format'],
			'opt'		=> $_POST['opt'],
			'rnd'		=> isset($_POST['rnd']),
			'params'	=> $_POST['params'],
			'enabled'	=> $_POST['enabled'] == 'true',
			'style'		=> $_POST['style'],
			'created'	=> current_time('mysql', 1),
			'modified'	=> current_time('mysql', 1),
		);
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
		return true;
	}

	function editBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_POST['action'])) return false;
		check_admin_referer('wpcontaxe-edit_' . $_POST['id']);
/*
		if (!isset($GLOBALS['WPCONTAXE_ADFORMATS'][$_POST['format']])) {
			$msg	.= '<li>Bitte wählen Sie ein Format.</li>';
		}
*/
		$id = $_POST['id'];
		$options['banners'][$id]['id']			= $id;
		$options['banners'][$id]['name']		= empty($_POST['name']) ? 'Unbenannt ' . $id: $_POST['name'];
		$options['banners'][$id]['channel']		= $_POST['channel'];
		$options['banners'][$id]['format']		= $_POST['format'];
		$options['banners'][$id]['opt']			= $_POST['opt'];
		$options['banners'][$id]['rnd']			= isset($_POST['rnd']);
		$options['banners'][$id]['params']		= $_POST['params'];
		$options['banners'][$id]['enabled']		= isset($_POST['enabled']);
		$options['banners'][$id]['modified']	= current_time('mysql', 1);
		$options['banners'][$id]['enabled']		= $_POST['enabled'] == 'true';
		$options['banners'][$id]['style']		= $_POST['style'];
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Banner gespeichert.</p></div>
<?php
		return true;
	}

	function deleteBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_GET['action'])) return false;
		check_admin_referer('wpcontaxe-delete_' . $_GET['id']);
		$id = $_GET['id'];
		unset($options['banners'][$id]);
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
		return true;
	}

	function getMode($options) {
		switch (true) {
			case is_preview():							return 'demo';							break;
			case current_user_can('manage_options'):	return $options['global_adminssee'];	break;
			case is_user_logged_in():					return $options['global_userssee'];		break;
			default:									return $options['global_visitorssee'];	break;
		}
	}

	function getBannerURL($id, $demo = false) {
		$options = $this->getAdminOptions();
		if (!$demo && ($mode = $this->getMode($options)) == 'nothing') return '';
		if ($demo) $mode = 'demo';

		if (!$demo && (!isset($options['banners'][$id]) || !$options['banners'][$id]['enabled'])) return '';

		$channel = $options['banners'][$id]['channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return '';

		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['banners'][$id]['format'];
		$url.= '&c='	. urlencode($channel);
		$url.= '&opt='	. $options['banners'][$id]['opt'];

		if (!empty($options['banners'][$id]['style']))	$url.= '&s='	. $options['banners'][$id]['style'];
		if ($options['banners'][$id]['rnd'])			$url.= '&rnd=1';
		if ($mode == 'demo')							$url.= '&demo=1';

		$url.= $options['banners'][$id]['params'];
		return $url;
	}
	
	function getBannerCode($url, $counts = true) {
		if (is_feed() || is_trackback() || is_404()) return '';
		if ($url == '') return '';
		if ($counts) {
			if ($this->cntBanners > 5) return '';
			$this->cntBanners++;
		}
		return '<script language="JavaScript1.1" type="text/javascript" src="' . wp_specialchars($url) . '"></script>';
	}

	function showBanner($id) {
		$options = $this->getAdminOptions();
		if (!isset($options['banners'][$id])) {
			foreach ($options['banners'] as $banner) {
				if ($banner['name'] == $id) {
					$id = $banner['id'];
					break;
				}
			}
		}
		if (!isset($options['banners'][$id])) {
			echo '<!--wpcontaxe: could not find banner-->';
			return;
		}
		$url = $this->getBannerURL($id);
		echo $this->getBannerCode($url);
		
	}

	function showDemoBanner($id) {
		$url = $this->getBannerURL($id, true);
		echo $this->getBannerCode($url, false);
	}


	function addHighlighter() {
		$options = $this->getAdminOptions();
		if (!$options['highlighter_enabled']) return;
		if (($mode = $this->getMode($options)) == 'nothing') return;

		$channel = $options['highlighter_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= ($options['highlighter_bigfont'] ? '54' : '20');
		$url.= '&c='	. urlencode($channel);
		$url.= '&hw='	. urlencode($options['highlighter_words']);
		$url.= '&wr='	. urlencode($options['highlighter_repeat']);
		$url.= '&pct='	. urlencode($options['highlighter_delay']);
		if (!empty($options['highlighter_style']))	$url.= '&s=' . $options['highlighter_style'];
		if ($mode == 'demo') $url.= '&demo=1';
		echo $this->getBannerCode($url, false);
	}

	function showDemoHighlighter() {
		$options = $this->getAdminOptions();
		$channel = $options['highlighter_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= ($options['highlighter_bigfont'] ? '54' : '20');
		$url.= '&c='	. urlencode($channel);
		$url.= '&hw='	. urlencode($options['highlighter_words']);
		$url.= '&wr='	. urlencode($options['highlighter_repeat']);
		$url.= '&pct='	. urlencode($options['highlighter_delay']);
		$url.= '&demo=1&kws=10356';
		if (!empty($options['highlighter_style']))	$url.= '&s=' . $options['highlighter_style'];
		echo $this->getBannerCode($url, false);
	}
	
	function addIAS() {
		$options = $this->getAdminOptions();
		if (!$options['ias_enabled']) return;
		if (($mode = $this->getMode($options)) == 'nothing') return;

		$channel = $options['ias_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['ias_type'];
		$url.= '&c=' . urlencode($channel);
		if (!empty($options['ias_style']))	$url.= '&s=' . $options['ias_style'];
		if ($mode == 'demo') $url.= '&demo=1';
		echo $this->getBannerCode($url, false);
?>
<script language="JavaScript1.1" type="text/javascript">
    ContaxeSTHandlerInst.AddId('s');
</script>
<?php
	}

	function showDemoIAS() {
		$options = $this->getAdminOptions();
		$channel = $options['ias_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['ias_type'];
		$url.= '&c=' . urlencode($channel);
		$url.= '&demo=1';
		if (!empty($options['ias_style']))	$url.= '&s=' . $options['ias_style'];
		echo $this->getBannerCode($url, false);
	}

	/*
	 * parts of the following code are borrowed from AdSense Manager 
	 * http://wordpress.org/extend/plugins/adsense-manager/
	 * by Martin Fitzpatrick (http://www.mutube.com/)
	 * released under GPLv2
	 */
	function addEditorButton() {
		$options = $this->getAdminOptions();
		if (
			!strpos($_SERVER['REQUEST_URI'], 'post.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'post-new.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'page.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'page-new.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'bookmarklet.php')
		) return;
?>
<script language="JavaScript" type="text/javascript">
<!--
var ed_contaxe = document.createElement("select");
	
ed_contaxe.setAttribute("onchange", "add_contaxe(this)");

ed_contaxe.setAttribute("class", "ed_button");
ed_contaxe.setAttribute("title", "Contaxe-Werbung einfügen");
ed_contaxe.setAttribute("id", "ed_contaxe");					

opt_contaxe = document.createElement("option");
opt_contaxe.value='';
opt_contaxe.innerHTML='Contaxe...';
opt_contaxe.style.fontWeight='bold';
ed_contaxe.appendChild(opt_contaxe);

<?php
		$other_options = array(
			'no_banners'	=> '    Keine Banner einfügen',
			'no_hl'			=> '    Highlighter deaktivieren',
			'no_ads'		=> '    Keine Werbung',
			''				=> 'Banner einfügen:'
		);
		foreach ($other_options as $key => $value) {
?>
var opt = document.createElement("option");
opt.value='<?php echo wp_specialchars($key); ?>';
opt.innerHTML='<?php echo $value; ?>';
ed_contaxe.appendChild(opt);
<?php 
		}

		if (sizeof($options['banners']) != 0) {
			foreach ($options['banners'] as $banner) {
?>
var opt = document.createElement("option");
opt.value='<?php echo wp_specialchars($banner['name']); ?>';
opt.innerHTML='    <?php echo $banner['name']; ?>';
ed_contaxe.appendChild(opt);
<?php
			}
		}
?>
document.getElementById("ed_toolbar").insertBefore(ed_contaxe, document.getElementById("ed_spell"));
			    
/* Below is a kludge for IE, which causes it to re-read the state of onChange etc. set above. */
if (navigator.appName == 'Microsoft Internet Explorer') {
	document.getElementById("ed_toolbar").innerHTML=document.getElementById("ed_toolbar").innerHTML; 
}
				
function add_contaxe(element) {
	if (element.value == '') return;
	else if (element.value == 'no_ads')		{ contaxe_code = '<!--wpcontaxe_no_ads-->'; }
	else if (element.value == 'no_hl')		{ contaxe_code = '<!--wpcontaxe_no_hl-->'; }
	else if (element.value == 'no_banners')	{ contaxe_code = '<!--wpcontaxe_no_banners-->'; }
	else									{ contaxe_code = '<!--wpcontaxe#' + element.value + '-->';}

	contentField = document.getElementById("content");
	if (document.selection && !window.opera) {
		// IE compatibility
		contentField.value += contaxe_code;
	} else {
		if (contentField.selectionStart || contentField.selectionStart == '0') {
			var startPos = contentField.selectionStart;
			var endPos = contentField.selectionEnd;
			contentField.value = contentField.value.substring(0, startPos) + contaxe_code + contentField.value.substring(endPos, contentField.value.length);
		}
		else {
			contentField.value += contaxe_code;
		}
	}
	element.selectedIndex=0;
}
// -->
</script>
<?php
	}

	function registerWidget() {
		if (!function_exists('wp_register_sidebar_widget')) return;
		$class	= array('classname' => 'widget_wpcontaxe');
		$dims	= array('width' => 350, 'height' => 170);
		for ($i = 1; $i <= $this->numWidgets; $i++) {
			$id		= 'widget_wpcontaxe-' . $i;
			$name	= sprintf(__('Contaxe-Anzeige %d'), $i);
			wp_register_sidebar_widget($id, $name, array(&$this, 'callback_widget'), $class, $i);
			wp_register_widget_control($id, $name, array(&$this, 'callback_widget_control'), $dims, $i);
		}
	}

	function placeAds($type, $content) {
		global $WPCONTAXE_POSITIONS, $wp_query;
		$options	= $this->getAdminOptions();
		$top_center = $top_left = $top_right = $middle_center = $middle_left = $middle_right = $bottom_center = '';
		foreach ($options['positions'] as $id => $pos) {
			$position = $WPCONTAXE_POSITIONS[$id];
			if ($position['type'] != $type) continue;
			if ($type == 'multiple') {
				if ($pos['position'] > 0) {
					if ($pos['position'] != $wp_query->current_post + 1) continue;
				}
				if ($pos['position'] < 0) {
					if ($wp_query->post_count + $pos['position'] != $wp_query->current_post) continue;
				}
			}
			if (($code = $this->getBannerURL($pos['banner'])) == '') continue;
			$code = $this->getBannerCode($code);
			switch (true) {
				case $position['valign'] == 'top' && $position['align'] == 'center':
					$top_center	= '<p style="text-align: center;">'				. $code . '</p>'; break;
				case $position['valign'] == 'top' && $position['align'] == 'left':
					$top_left	= '<p style="float: left; margin: 4px;">'		. $code . '</p>'; break;
				case $position['valign'] == 'top' && $position['align'] == 'right':
					$top_right	= '<p style="float: right; margin: 4px;">'		. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'center':
					$middle_center	= '<p style="text-align: center;">'			. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'left':
					$middle_left	= '<p style="float: left; margin: 4px;">'	. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'right':
					$middle_right	= '<p style="float: right; margin: 4px;">'	. $code . '</p>'; break;
				case $position['valign'] == 'bottom' && $position['align'] == 'center':
					$bottom_center	= '<p style="text-align: center;">'			. $code . '</p>'; break;
				default:
					break;
			}
		}
		$middle = $middle_center . $middle_left . $middle_right;
		$content = $this->injectIntoMiddle($content, $middle);
		return $top_center . $top_left . $top_right . $content . $bottom_center;
	}

	function callback_widget_text($content) {
		return $this->callback_content($content, FALSE);
	}

	function callback_content($content, $place_auto_ads = TRUE) {
		$options	= $this->getAdminOptions();
		$type		= '';
		if (strpos($content, '<!--wpcontaxe_no_ads-->') !== FALSE) {
			$content = str_replace('<!--wpcontaxe_no_ads-->', '<!--wpcontaxe: Werbung komplett deaktiviert-->', $content);
			return '<div class="chlforbidden">' . $content . '</div>';
		}
		while (preg_match('/<!--wpcontaxe#(.*?)-->/', $content, $match) == 1) {
			$name = $match[1];
			$code = '';
			foreach ($options['banners'] as $banner) {
				if (wp_specialchars($banner['name']) == $name) {
					$code = $this->getBannerCode($this->getBannerURL($banner['id']));
					break;
				}
			}
			$content = str_replace('<!--wpcontaxe#' . $name . '-->', $code, $content);
		}
		if (strpos($content, '<!--wpcontaxe_no_hl-->') !== FALSE) {
			$content = str_replace('<!--wpcontaxe_no_hl-->', '<!--wpcontaxe: Highlighter deaktiviert-->', $content);
			$content = '<div class="chlforbidden">' . $content . '</div>';
		}
		if (strpos($content, '<!--wpcontaxe_no_banners-->') !== FALSE) {
			return str_replace('<!--wpcontaxe_no_banners-->', '<!--wpcontaxe: Keine Banner in diesem Beitrag-->', $content);
		}
		if (!$place_auto_ads) return $content;
		switch (true) {
			case is_single():
				return $this->placeAds('single',	$content);
			case is_page():
				return $this->placeAds('page',		$content);
			default:
				return $this->placeAds('multiple',	$content);
				break;
		}
	}

	function callback_wp_footer() {
		$this->addHighlighter();
		$this->addIAS();
		$this->addEditorButton();
	}

	function callback_widget($args, $number) {
		extract($args);
		$options	= $this->getAdminOptions();
		if (($url = $this->getBannerURL($options['widgets'][$number]['banner'])) == '') return;
?>
			<?php echo $before_widget; ?>
				<?php echo $before_title . wp_specialchars($options['widgets'][$number]['title']) . $after_title; ?>
				<p style="text-align: center; margin-top: 10px;"><?php echo $this->getBannerCode($url); ?></p>
			<?php echo $after_widget; ?>
<?php
	}

	function callback_widget_control($number) {
		$options	= $this->getAdminOptions();
		if (isset($_POST['wpcontaxe-submit-' . $number])) {
			$options['widgets'][$number]['title']	= $_POST['wpcontaxe-title-' . $number];
			$options['widgets'][$number]['banner']	= $_POST['wpcontaxe-banner-' . $number];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
		}
?>
<p><label for="wpcontaxe-title-<?php echo $number; ?>"><?php _e('Title:'); ?></label></p> <input style="width: 350px;" id="wpcontaxe-title-<?php echo $number; ?>" name="wpcontaxe-title-<?php echo $number; ?>" type="text" value="<?php echo attribute_escape($options['widgets'][$number]['title']); ?>" />

<p><label for="wpcontaxe-banner-<?php echo $number; ?>"><?php _e('Banner:'); ?></label></p>
<select style="width: 350px;" id="wpcontaxe-banner-<?php echo $number; ?>" name="wpcontaxe-banner-<?php echo $number; ?>">
<?php
		foreach ($options['banners'] as $banner) {
			echo '<option value="' . $banner['id'] . '"' . ( $banner['id'] == $options['widgets'][$number]['banner'] ? ' selected="selected"' : '' ) . '>' . $banner['id']  . ' - ' . attribute_escape($banner['name']) . (!$banner['enabled'] ? ' (deaktiviert)' : '') . "</option>\n";
		}
?>
</select>
<input type="hidden" id="wpcontaxe-submit-<?php echo $number; ?>" name="wpcontaxe-submit-<?php echo $number; ?>" value="1" />
<?php
	}

	/*
	 * parts of the following function are borrowed from adman 
	 * http://wp.uberdose.com/2006/11/05/adman/
	 * Copyright (C) 2007 uberdose.com (adman AT uberdose DOT com)
	 * released under GPLv2
	 */
	function get_occurrences($content, $what) {
		$result = array();
		$pos = 0;
		while($pos !== false) {
			$pos = strpos($content, $what, $pos);
			if ($pos === false) {
				return $result;
			}
			$pos += strlen($what) + 1;
			array_push($result, $pos);
			if ($pos >= strlen($content)) {
				return $result;
			}
		}
		return $result;
	}

	/*
	 * parts of the following function are borrowed from adman 
	 * http://wp.uberdose.com/2006/11/05/adman/
	 * Copyright (C) 2007 uberdose.com (adman AT uberdose DOT com)
	 * released under GPLv2
	 */
	function injectIntoMiddle($content, $code) {
		if ($code == '') return $content;
		$middle = intval(strlen($content) / 2);
		$positions = $this->get_occurrences($content, '</p>');
		$positions = array_merge($positions, $this->get_occurrences($content, '</div>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</ul>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</ol>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</pre>'));
		$deviations = array();
		foreach ($positions as $pos) {
			$diff = abs($pos - $middle);
			$deviations[$diff] = $pos;
		}
		ksort($deviations);
		$final = array_shift($deviations);
		if ($final > 0) $content = substr($content, 0, $final - 1) . $code . substr($content, $final);
		return $content;
	}
}

function wpcontaxe_banner($id) {
	$GLOBALS['wpcontaxe']->showBanner($id);
}

}

$wpcontaxe = new WPContaxe();

register_activation_hook(__FILE__, array(&$wpcontaxe, 'activatePlugin'));

add_action('init',			array(&$wpcontaxe, 'registerWidget'));
add_action('admin_menu',	array(&$wpcontaxe, 'registerAdminMenu'));

add_action('wp_footer',		array(&$wpcontaxe, 'callback_wp_footer'));
add_action('admin_footer',	array(&$wpcontaxe, 'addEditorButton'));

add_filter('the_content',	array(&$wpcontaxe, 'callback_content'), 100);
add_filter('the_excerpt',	array(&$wpcontaxe, 'callback_content'), 100);
add_filter('widget_text',	array(&$wpcontaxe, 'callback_widget_text'), 1);

?>
